# this is a simple python script to capture the UDP packets
# that are broadcast by dash launch, display that info
# in human readable form and log the data to a csv file
import socket, sys, time

port = 7030

s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
s.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
s.setsockopt(socket.SOL_SOCKET, socket.SO_BROADCAST, 1)
s.bind(('', port))
divisor = float(256)
header = 'CPU,GPU,EDRAM,MOBO,UNK,Time,Date\n'

def tempPoll(lf):
	message = s.recv(16)
	# uncomment this bit if you want to view the raw data too
	# out_str = "raw: "
	# for num in xrange(16):
		# out_str += "0x%02x " % (ord(message[num]))
	# print out_str
	if ord(message[0]) == 0x7:
		cpu = float((ord(message[1])+(ord(message[2])<<8))/divisor)
		gpu = float((ord(message[3])+(ord(message[4])<<8))/divisor)
		edr = float((ord(message[5])+(ord(message[6])<<8))/divisor)
		mob = float((ord(message[7])+(ord(message[8])<<8))/divisor)
		st = "%0.1f,%0.1f,%0.1f,%0.1f,%d,%s\n" % (cpu, gpu, edr, mob, ord(message[9]), time.strftime("%H:%M:%S,%m/%d/%Y"))
		lf.write(st)
		print "CPU: %0.1fC GPU: %0.1fC EDRAM: %0.1fC MOBO: %0.1fC Unk: %d %s" % (cpu, gpu, edr, mob, ord(message[9]), time.strftime("%I:%M:%S%p"))
	else:
		print "ERRROR!!! 0x%x is not a temp reply!!!" % (ord(message[0]))

if __name__ == '__main__':
	logfile = 'temps.csv'
	if (len(sys.argv) == 1):
		logfile = "temps_%s.csv" % (time.strftime("%I.%M.%S%p_%m.%d.%Y"))
		lfile = open(logfile, 'w')
	else:
		logfile = sys.argv[0]
	print "Opening log: %s" % (logfile)
	lfile = open(logfile, 'w')
	lfile.write(header)

	while True:
		try:
			tempPoll(lfile)
		except KeyboardInterrupt:
			lfile.close()
			sys.exit()
			
